summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorKieran Bingham <kieran.bingham@ideasonboard.com>2022-11-01 13:02:17 +0000
committerKieran Bingham <kieran.bingham@ideasonboard.com>2022-11-22 12:11:41 +0000
commitb101cefde93dc8e01d591913df2d5039a14c0289 (patch)
treecccb154c4f61b2a7e5e5b5603f1029113674b84e
parent9fbd0e614e81d9bfb113b659fb650942baa51e37 (diff)
scripts: Add gen-version.sh
Import the gen-version.sh helper script from libcamera [0] [0] https://git.libcamera.org/libcamera/libcamera.git/tree/utils/gen-version.sh?h=v0.0.1 Reviewed-by: Daniel Scally <dan.scally@ideasonboard.com> Signed-off-by: Kieran Bingham <kieran.bingham@ideasonboard.com>
-rwxr-xr-xscripts/gen-version.sh50
1 files changed, 50 insertions, 0 deletions
diff --git a/scripts/gen-version.sh b/scripts/gen-version.sh
new file mode 100755
index 0000000..eb7c726
--- /dev/null
+++ b/scripts/gen-version.sh
@@ -0,0 +1,50 @@
+#!/bin/sh
+
+# SPDX-License-Identifier: GPL-2.0-or-later
+# Generate a version string using git describe
+
+build_dir="$1"
+src_dir="$2"
+
+# If .tarball-version exists, output the version string from the file and exit.
+# This file is auto-generated on a 'meson dist' command from the run-dist.sh
+# script.
+if [ -n "$src_dir" ] && [ -f "$src_dir"/.tarball-version ]
+then
+ cat "$src_dir"/.tarball-version
+ exit 0
+fi
+
+# Bail out if the directory isn't under git control
+git_dir=$(git rev-parse --git-dir 2>&1) || exit 1
+
+# Derive the source directory from the git directory if not specified.
+if [ -z "$src_dir" ]
+then
+ src_dir=$(readlink -f "$git_dir/..")
+fi
+
+# Get a short description from the tree.
+version=$(git describe --abbrev=8 --match "v[0-9]*" 2>/dev/null)
+
+if [ -z "$version" ]
+then
+ # Handle an un-tagged repository
+ sha=$(git describe --abbrev=8 --always 2>/dev/null)
+ commits=$(git log --oneline | wc -l 2>/dev/null)
+ version="v0.0.0-$commits-g$sha"
+fi
+
+# Append a '-dirty' suffix if the working tree is dirty. Prevent false
+# positives due to changed timestamps by running git update-index.
+if [ -z "$build_dir" ] || (echo "$build_dir" | grep -q "$src_dir")
+then
+ git update-index --refresh > /dev/null 2>&1
+fi
+git diff-index --quiet HEAD || version="$version-dirty ($(date --iso-8601=seconds))"
+
+# Replace first '-' with a '+' to denote build metadata, strip the 'g' in from
+# of the git SHA1 and remove the initial 'v'.
+version=$(echo "$version" | sed -e 's/-/+/' | sed -e 's/-g/-/' | cut -c 2-)
+
+echo "$version"